//ADC SPI receiver

module spirec(CLK, DATA, RCV, RCVD, DIN, AD_CONV);
	input CLK;
	output [31:0] DATA;
	input RCV;				//start receive
	output RCVD;			//data received
	input DIN;				//serial in
	output AD_CONV;			//AD control

	reg [33:0] sh_in=0;
	reg rcvd=0;
	reg adconv=0;
	reg [5:0]dcount=0;
	reg [1:0]eldet=0;		//ldetetls
	reg [1:0]state=0;

	always@(posedge CLK)
		begin
		eldet[0]<=RCV;
		eldet[1]<=eldet[0];
		if(state==2'h0)
			begin
			if(eldet[1:0]==2'b01)
				begin
				adconv<=1;
				state<=2'h1;
				end
			else
				begin 
				rcvd<=0;
				adconv<=0;
				end
			end
		if(state==2'h1)
			begin
			state<=2'h2;
			adconv<=0;
			dcount<=6'h00;
			end
		if(state==2'h2)
			begin
			dcount<=dcount+1;
			sh_in[33]<=DIN;
			sh_in[32:0]<=sh_in[33:1];
			if(dcount==6'h21)			//21!
				begin
				rcvd<=1;
				state<=2'h0;
				end
			end

		end

	assign DATA[31:0]=sh_in[33:2];
	assign RCVD=rcvd;
	assign AD_CONV=adconv;

endmodule
